天天看點

hdu 2389 Rain on your Parade(二分圖最大比對,Hopcroft-Karp) Rain on your Parade

Rain on your Parade

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 655350/165535 K (Java/Others)

Total Submission(s): 3659    Accepted Submission(s): 1186

Problem Description You’re giving a party in the garden of your villa by the sea. The party is a huge success, and everyone is here. It’s a warm, sunny evening, and a soothing wind sends fresh, salty air from the sea. The evening is progressing just as you had imagined. It could be the perfect end of a beautiful day.

But nothing ever is perfect. One of your guests works in weather forecasting. He suddenly yells, “I know that breeze! It means its going to rain heavily in just a few minutes!” Your guests all wear their best dresses and really would not like to get wet, hence they stand terrified when hearing the bad news.

You have prepared a few umbrellas which can protect a few of your guests. The umbrellas are small, and since your guests are all slightly snobbish, no guest will share an umbrella with other guests. The umbrellas are spread across your (gigantic) garden, just like your guests. To complicate matters even more, some of your guests can’t run as fast as the others.

Can you help your guests so that as many as possible find an umbrella before it starts to pour? 

Given the positions and speeds of all your guests, the positions of the umbrellas, and the time until it starts to rain, find out how many of your guests can at most reach an umbrella. Two guests do not want to share an umbrella, however. 

Input The input starts with a line containing a single integer, the number of test cases.

Each test case starts with a line containing the time t in minutes until it will start to rain (1 <=t <= 5). The next line contains the number of guests m (1 <= m <= 3000), followed by m lines containing x- and y-coordinates as well as the speed si in units per minute (1 <= s i <= 3000) of the guest as integers, separated by spaces. After the guests, a single line contains n (1 <= n <= 3000), the number of umbrellas, followed by n lines containing the integer coordinates of each umbrella, separated by a space.

The absolute value of all coordinates is less than 10000.

Output For each test case, write a line containing “Scenario #i:”, where i is the number of the test case starting at 1. Then, write a single line that contains the number of guests that can at most reach an umbrella before it starts to rain. Terminate every test case with a blank line.

Sample Input

2
1
2
1 0 3
3 0 3
2
4 0
6 0
1
2
1 1 2
3 3 2
2
2 2
4 4
        

Sample Output

Scenario #1:
2

Scenario #2:
2
        

  題意:有m個人,n把傘。現在給你人和傘的坐标,人的速度,距離下雨的時間,問你最多能有幾個人能拿到傘。距離為直線距離

思路:此題和北大一個地鼠的題一樣,不過資料量大了..匈牙利算法無限TLE

這裡要用一個匈牙利算法的優化版本,叫Hopcroft-Karp

關于如何優化可以去百度,本人了解的也不是很深刻..覺得跟網絡流的層次網絡有點像

好像用到這個算法的題目也少之又少,是以直接當模闆算了。

代碼:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <queue>
using namespace std;
#define N 3002
#define INF 99999999
int m,n,t;
int nx,ny,xline[N],yline[N],dy[N],dx[N];
int vis[N],dis;
struct Node
{
    long long x,y,v;
}p[N];
struct Edge
{
    int v,next;
}edge[N*N];
int cnt,head[N];
void init()
{
    cnt=0;
    memset(head,-1,sizeof(head));
    memset(xline,-1,sizeof(xline));
    memset(yline,-1,sizeof(yline));
}
void addedge(int u,int v)
{
    edge[cnt].v=v;
    edge[cnt].next=head[u];
    head[u]=cnt++;
}
long long dist(Node a,Node b)
{
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}
int bfs()
{
    queue<int>que;
    dis=INF;
    memset(dx,-1,sizeof(dx));
    memset(dy,-1,sizeof(dy));
    for(int i=1;i<=m;i++)
    {
        if(xline[i]==-1)
        {
            que.push(i);
            dx[i]=0;
        }
    }
    while(!que.empty())
    {
        int u=que.front();que.pop();
        if(dx[u]>dis) break;
        for(int i=head[u];i!=-1;i=edge[i].next)
        {
            int v = edge[i].v;
            if(dy[v] == -1)
            {
                dy[v] = dx[u] + 1;
                if(yline[v] == -1) dis = dy[v];
                else
                {
                    dx[yline[v]] = dy[v]+1;
                    que.push(yline[v]);
                }
            }
        }
    }
    return dis!=INF;
}
int can(int t)
{
    for(int i=head[t];i!=-1;i=edge[i].next)
    {
        int v=edge[i].v;
        if(!vis[v]&&dy[v]==dx[t]+1)
        {
            vis[v]=1;
            if(yline[v]!=-1&&dy[v]==dis) continue;
            if(yline[v]==-1||can(yline[v]))
            {
                yline[v]=t,xline[t]=v;
                return 1;
            }
        }
    }
    return 0;
}
int Maxmatch()
{
    int ans=0;
    while(bfs())
    {
        memset(vis,0,sizeof(vis));
        for(int i=1;i<=m;i++)
            if(xline[i]==-1&&can(i))
                ans++;
    }
    return ans;
}
int main()
{
    int T,tot=1;
    int x,y;
    Node a;
    scanf("%d",&T);
    while(T--)
    {
        init();
        scanf("%d %d",&t,&m);
        for(int i=1;i<=m;i++)
            {
                scanf("%lld %lld %lld",&p[i].x,&p[i].y,&p[i].v);
                p[i].v*=t;
                p[i].v=p[i].v*p[i].v;
            }
        scanf("%d",&n);
        for(int i=1;i<=n;i++)
        {
            scanf("%lld %lld",&a.x,&a.y);
            for(int j=1;j<=m;j++)
            {
                long long d=dist(a,p[j]);
                if(p[j].v>=d)
                    addedge(j,i);
            }
        }
        int ans=Maxmatch();
        printf("Scenario #%d:\n",tot++);
        printf("%d\n\n",ans);
    }
    return 0;
}